

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Cairo.Structs
    (     module GI.Cairo.Structs.Context         ,
    module GI.Cairo.Structs.Device          ,
    module GI.Cairo.Structs.FontFace        ,
    module GI.Cairo.Structs.FontOptions     ,
    module GI.Cairo.Structs.Matrix          ,
    module GI.Cairo.Structs.Path            ,
    module GI.Cairo.Structs.Pattern         ,
    module GI.Cairo.Structs.Rectangle       ,
    module GI.Cairo.Structs.RectangleInt    ,
    module GI.Cairo.Structs.Region          ,
    module GI.Cairo.Structs.ScaledFont      ,
    module GI.Cairo.Structs.Surface         ,


    ) where

import GI.Cairo.Structs.Context
import GI.Cairo.Structs.Device
import GI.Cairo.Structs.FontFace
import GI.Cairo.Structs.FontOptions
import GI.Cairo.Structs.Matrix
import GI.Cairo.Structs.Path
import GI.Cairo.Structs.Pattern
import GI.Cairo.Structs.Rectangle
import GI.Cairo.Structs.RectangleInt
import GI.Cairo.Structs.Region
import GI.Cairo.Structs.ScaledFont
import GI.Cairo.Structs.Surface

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL



